package com.jeeplus.test.luckyDraw.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.test.luckyDraw.service.LuckyDrawMembersService;
import com.jeeplus.test.luckyDraw.service.dto.LuckyDrawMembersDto;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @author: 王强
 * @create: 2023-02-28 11:08
 **/
@RestController
@Api(tags ="抽奖-人员")
@RequestMapping(value = "/luckyDraw/member")
public class LuckyDrawMembersController {
    @Resource
    private LuckyDrawMembersService membersService;


    /**
     * 删除
     * @param id
     * @return
     */
    @ApiOperation(value = "删除")
    @GetMapping("/remove")
    public ResponseEntity<String> remove(@RequestParam String id){
        String s = membersService.remove(id);
        return ResponseEntity.ok(s);
    }

    /**
     * 新增/修改
     * @param dto
     * @return
     */
    @ApiOperation(value = "新增、修改")
    @PostMapping("/save")
    public ResponseEntity<String> save(@RequestBody LuckyDrawMembersDto dto) throws Exception{
        String s = membersService.save(dto);
        if (s == "1") {
            return ResponseUtil.newInstance().error ("名字重复，请重新修改");
        }else if (s == "2"){
            return ResponseUtil.newInstance().error ("新增失败");
        }
        return ResponseUtil.newInstance().ok ("操作成功");
    }

    /**
     * 查询
     * @param id
     * @return
     */
    @ApiOperation(value = "查询")
    @GetMapping("/findById")
    public ResponseEntity<LuckyDrawMembersDto> findById(@RequestParam String id) throws Exception{
        LuckyDrawMembersDto dto = membersService.findById(id);
        return ResponseEntity.ok(dto);
    }

    /**
     * 列表查询
     * @param dto
     * @return
     */
    @ApiOperation(value = "列表查询")
    @GetMapping("/list")
    public ResponseEntity<IPage<LuckyDrawMembersDto>> list(Page<LuckyDrawMembersDto> page, LuckyDrawMembersDto dto) throws Exception{
        IPage<LuckyDrawMembersDto> iPage = membersService.list(page, dto);
        return ResponseEntity.ok(iPage);
    }
}
