package com.jeeplus.test.luckyDraw.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jeeplus.core.query.QueryWrapperGenerator;
import com.jeeplus.sys.service.dto.UserDTO;
import com.jeeplus.sys.utils.StringUtils;
import com.jeeplus.sys.utils.UserUtils;
import com.jeeplus.test.luckyDraw.domain.LuckyDrawInfo;
import com.jeeplus.test.luckyDraw.mapper.LuckyDrawInfoMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jeeplus.test.luckyDraw.mapper.LuckyDrawMembersMapper;
import com.jeeplus.test.luckyDraw.service.dto.LuckyDrawInfoDto;
import org.springframework.stereotype.Service;
import org.springframework.beans.BeanUtils;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * @author: 王强
 * @create: 2023-02-28 11:02
 **/
@Service
@Transactional
public class LuckyDrawInfoService extends ServiceImpl<LuckyDrawInfoMapper, LuckyDrawInfo>{

    @Resource
    private LuckyDrawInfoMapper drawInfoMapper;

    @Resource
    private LuckyDrawMembersMapper membersMapper;


    /**
     * 列表查询
     */
    public IPage<LuckyDrawInfoDto> findList(Page<LuckyDrawInfoDto> page , LuckyDrawInfoDto dto) throws Exception{
        QueryWrapper<LuckyDrawInfoDto> queryWrapper = QueryWrapperGenerator.buildQueryCondition(dto, LuckyDrawInfoDto.class);

        queryWrapper.eq("lda.del_flag", "0");
        if (StringUtils.isNotEmpty(dto.getId())) {
            queryWrapper.eq("lda.events_id",dto.getId());
        }

        return drawInfoMapper.findList(page, queryWrapper);
    }

    public LuckyDrawInfoDto findByEventId(String id) {
        LuckyDrawInfoDto dto = drawInfoMapper.findByEventId(id);
        return dto;
    }

    public String luckyDraw(LuckyDrawInfoDto dto) throws Exception{
        // 获取当前登录人信息
        UserDTO userDTO = UserUtils.getCurrentUserDTO();
        return add(dto, userDTO);
    }

    /**
     *根据奖品数量随机抽取用户进行抽奖
     * @param dto
     * @param userDTO
     * @return
     * @throws Exception
     */
    public String add(LuckyDrawInfoDto dto, UserDTO userDTO) throws Exception{
        LuckyDrawInfo members = new LuckyDrawInfo();
        BeanUtils.copyProperties(dto, members);

        members.setCreateBy(userDTO.getId());
        members.setCreateDate(new Date());
        members.setUpdateBy(userDTO.getId());
        members.setUpdateDate(new Date());
        members.setDelFlag(0);
        members.setEventId(dto.getId());
        members.setAwardId(dto.getAwardId());
        members.setLuckyDrawFlag("1");
        //当抽奖前
        int num = Integer.parseInt(dto.getNumber());
        //根据奖品数量和活动id随机抽取用户进行抽奖
        List<String> list = drawInfoMapper.selectUserId(num,dto.getId());
        list.forEach(userId->{
            // 生成id
            String id = UUID.randomUUID().toString().replace("-", "");
            members.setId(id);
            members.setMemberId(userId);
            drawInfoMapper.insert(members);
        });
        return "ok";
    }
}
